
** dBase IV AR_WID Function

FUNCTION ar_wid
PARAMETERS ar_name
PRIVATE ar_name, rvalue, min, mid, max

IF type(ar_name + '[1]') # 'U' .or. ;
   type(ar_name + '[1,1]') # 'U'     &&  we have an array

  min = 0
  max = 2048                &&  larger than max array size

  IF type(ar_name + '[1]') # 'U' &&  one-dim. array
    rvalue = 1              &&  the width is one
  ELSE

    DO WHILE .t.              &&  binary seek

      mid = (min + max)/2

      IF type(ar_name+'[1,mid]') # 'U'  && not undefined

***  If the next higher element is undefined then the width
***  of the array equals the mid value.

        IF type(ar_name+'[1,mid+1]') = 'U'
          rvalue = mid
          EXIT
        ELSE
          min = mid
        ENDIF

      ELSE                    &&  if array element exists
        max = mid
      ENDIF

    ENDDO

  ENDIF

ELSE                        &&  not an array
  ?? chr(7)
  rvalue = -1
ENDIF

RETURN(rvalue)

