
FoxPro AR_WID Function

FUNCTION ar_wid
PARAMETERS ar_name
PRIVATE ar_name, a_len, rvalue, min, mid, max

***  FoxPro Code  ***

IF type(ar_name + '[1,1]') # 'U' &&  we have an array
  min = 0
  max = 4096                &&  larger than max array width

  IF type(ar_name + '[3600,1]') # 'U' && one-dimension array
    rvalue = 1              &&  the width is one
  ELSE
    a_len = ar_len(ar_name)  && get array length

    DO WHILE .t.

      mid = (min + max)/2

      IF type(ar_name+'[a_len,mid]') # 'U'  && not undefined

***  If the next higher element is undefined then the width
***  of the array equals the mid value.

        IF type(ar_name+'[a_len,mid+1]') = 'U'
          rvalue = mid
          EXIT
        ELSE
          min = mid
        ENDIF

      ELSE                    &&  if array element exists
        max = mid
      ENDIF

    ENDDO

  ENDIF

ELSE                        &&  not an array
  ?? chr(7)
  rvalue = -1

ENDIF

RETURN(rvalue)

