
Simple Maximum Element Length Array Program

FUNCTION ar_maxl
PARAMETERS ar_name
PRIVATE ar_name, ar_len, max_len, el_len, i

***  First Cut  ***

max_len = 0
ar_len = ar_len(ar_name)

IF .not. isarray(ar_name)     &&  if memvar is not an array
  ?? chr(7)
  RETURN(-1)
ENDIF

ar_len = ar_len(ar_name)      &&  how long is the array
i = 1

IF ar_1dim(ar_name)           &&  if one-dimensional

  DO WHILE i <= ar_len
    el_len = len(&ar_name[i])

    IF max_len < el_len
      max_len = el_len
    ENDIF

    i = i + 1

  ENDDO

ELSE                          &&  if array two-dim.

  DO WHILE i <= ar_len
    el_len = len(&ar_name[i,1])

    IF max_len < el_len
      max_len = el_len
    ENDIF

    i = i + 1

  ENDDO

ENDIF

RETURN(max_len)

