
Finished AR_MAXL Function

FUNCTION ar_maxl
PARAMETERS ar_name, col_no
PRIVATE ar_name, col_no, ar_len, max_len, el_len, i

max_len = 0
ar_len = ar_len(ar_name)

IF .not. isarray(ar_name)     &&  if memver is not an array
  RETURN(-1)
ENDIF

ar_len = ar_len(ar_name)      &&  how long is the array
i = 1

IF ar_1dim(ar_name)           &&  if one-dimensional

  DO WHILE i <= ar_len

    IF type(ar_name+'[i]')= 'C'  &&  if element is character
      el_len = len(&ar_name[i])

      IF max_len < el_len
        max_len = el_len
      ENDIF

    ENDIF

    i = i + 1

  ENDDO

ELSE                          &&  if array two-dim.

  DO WHILE i <= ar_len

    IF type(ar_name + '[i,col_no]')= 'C' 
      el_len = len(&ar_name[i,col_no])

      IF max_len < el_len
        max_len = el_len
      ENDIF

    ENDIF

    i = i + 1

  ENDDO

ENDIF

RETURN(max_len)

